#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Collections.Specialized;
using Syncfusion.Windows.Forms.Grid;
using System.Runtime.InteropServices;

namespace GridListControlSample
{
	

	public class ListBoxSample3 : Form
	{
		private GridListControl ListBox1;
		private TextBox textBox1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.ListBox listBox2;
		
		[DllImport("user32.dll", CharSet=CharSet.Auto)] 
		static extern IntPtr SendMessage(IntPtr hWnd, uint Msg, int wParam, string lParam); 

		[DllImport("User32.Dll")]
		public static extern bool SendMessage(IntPtr hWnd,int Msg,int wParam,int lParam);
		public const int WM_VSCROLL = 0x0115;
		public const int SB_LINEDOWN = 1;
		private const int SB_PAGETOP = 6; // Scrolls to the upper left


      
		[STAThread]
		public static void Main() 
		{
			Application.Run(new ListBoxSample3()) ;
		}

		public ListBoxSample3()
		{
			
			InitializeComponent();

			#region ItemList
			// Populates the list box using DataSource. 
			// DisplayMember is used to display just the long name of each state.
			ArrayList USStates = new ArrayList()   ;
			USStates.Add(new USState("Alaska", "AK", 1));
			USStates.Add(new USState("Arizona", "AZ", 2));
			USStates.Add(new USState("Arkansas", "AK", 3));
			USStates.Add(new USState("California", "CA", 4));
			USStates.Add(new USState("Colorado", "CO", 5));
			USStates.Add(new USState("Connecticut", "CT", 6));
			USStates.Add(new USState("Delaware", "DE", 3));
			USStates.Add(new USState("Florida", "FL", 4));
			USStates.Add(new USState("Georgia", "GA", 1));
			USStates.Add(new USState("Hawaii", "HI", 0));
			USStates.Add(new USState("Idaho", "ID", 3));
			USStates.Add(new USState("Illinois", "IL", 2));
			USStates.Add(new USState("Indiana", "IN", 6));
			USStates.Add(new USState("Iowa", "IA", 5));
			USStates.Add(new USState("Kansas", "KA", 5));
			USStates.Add(new USState("Kentucky", "KY", 4));
			USStates.Add(new USState("Louisiana", "LA", 3));
			USStates.Add(new USState("Maine", "ME", 0));
			USStates.Add(new USState("Maryland", "MD", 0));
			USStates.Add(new USState("Massachusetts", "MA", 2));
			USStates.Add(new USState("Michigan", "MI", 1));
			USStates.Add(new USState("Minnesota", "MN", 6));
			USStates.Add(new USState("Mississippi", "MS", 5));
			USStates.Add(new USState("Missouri", "MO", 2));
			USStates.Add(new USState("Montana", "MT", 1));
			USStates.Add(new USState("Nebraska", "NE", 4));
			USStates.Add(new USState("Nevada", "NV", 0));
			USStates.Add(new USState("New Hampshire", "NH", 3));
			USStates.Add(new USState("New Jersey", "NJ", 3));
			USStates.Add(new USState("New Mexico", "NM", 2));
			USStates.Add(new USState("New York", "NY", 5));
			USStates.Add(new USState("North Carolina", "NC", 4));
			USStates.Add(new USState("North Dakota", "ND", 4));
			USStates.Add(new USState("Ohio", "OH", 1));
			USStates.Add(new USState("Oklahoma", "OK", 2));
			USStates.Add(new USState("Oregon", "OR", 5));
			USStates.Add(new USState("Pennsylvania", "PA", 0));
			USStates.Add(new USState("Rhode Island", "RI", 6));
			USStates.Add(new USState("South Carolina", "SC", 5));
			USStates.Add(new USState("South Dakota", "SD", 4));
			USStates.Add(new USState("Tennessee", "TN", 3));
			USStates.Add(new USState("Texas", "TX", 2));
			USStates.Add(new USState("Utah", "UT", 0));
			USStates.Add(new USState("Vermont", "VT", 1));
			USStates.Add(new USState("Virginia", "VA", 0));
			USStates.Add(new USState("Washington", "WA", 2));
			USStates.Add(new USState("West Virginia", "WV", 0));
			USStates.Add(new USState("Wisconsin", "WI", 3));
			USStates.Add(new USState("Wyoming", "WY", 5));
			


			StringCollection itemList = new StringCollection();
			
			itemList.Add("Alaska");
			itemList.Add("Arizona");
			itemList.Add("Arkansas");
			itemList.Add("California");
			itemList.Add("Colorado");
			itemList.Add("Connecticut");
			itemList.Add("Delaware");
			itemList.Add("Florida");
			itemList.Add("Georgia");
			itemList.Add("Hawaii");
			itemList.Add("Idaho");
			itemList.Add("Illinois");
			itemList.Add("Indiana");
			itemList.Add("Iowa");
			itemList.Add("Kansas");
			itemList.Add("Kentucky");
			itemList.Add("Louisiana");
			itemList.Add("Maine");
			itemList.Add("Maryland");
			itemList.Add("Massachusetts");
			itemList.Add("Michigan");
			itemList.Add("Minnesota");
			itemList.Add("Mississippi");
			itemList.Add("Missouri");
			itemList.Add("Montana");
			itemList.Add("Nebraska");
			itemList.Add("Nevada");
			itemList.Add("New Hampshire");
			itemList.Add("New Jersey");
			itemList.Add("New Mexico");
			itemList.Add("New York");
			itemList.Add("North Carolina");
			itemList.Add("North Dakota");
			itemList.Add("Ohio");
			itemList.Add("Oklahoma");
			itemList.Add("Oregon");
			itemList.Add("Pennsylvania");
			itemList.Add("Rhode Island");
			itemList.Add("South Carolina");
			itemList.Add("South Dakota");
			itemList.Add("Tennessee");
			itemList.Add("Texas");
			itemList.Add("Utah");
			itemList.Add("Vermont");
			itemList.Add("Virginia");
			itemList.Add("Washington");
			itemList.Add("West Virginia");
			itemList.Add("Wisconsin");
			itemList.Add("Wyoming");

			#endregion


			ListBox1.DataSource = USStates ;
			ListBox1.DisplayMember = "LongName";
			ListBox1.ValueMember = "LongName";
			listBox2.DataSource = itemList;
			this.ListBox1.Grid.DrawCell += new GridDrawCellEventHandler(Grid_DrawCell);
			this.ListBox1.Grid.Model.Options.DefaultGridBorderStyle = GridBorderStyle.None;
		
		}
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>

		private void InitializeComponent()
		{
			this.ListBox1 = new Syncfusion.Windows.Forms.Grid.GridListControl();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.listBox2 = new System.Windows.Forms.ListBox();
			this.button1 = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.ListBox1)).BeginInit();
			this.SuspendLayout();
			// 
			// ListBox1
			// 
			this.ListBox1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.ListBox1.BackColor = System.Drawing.SystemColors.Control;
			this.ListBox1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.ListBox1.FillLastColumn = true;
			this.ListBox1.ItemHeight = 17;
			this.ListBox1.Location = new System.Drawing.Point(212, 24);
			this.ListBox1.MultiColumn = false;
			this.ListBox1.Name = "ListBox1";
			this.ListBox1.Properties.BackgroundColor = System.Drawing.SystemColors.Window;
			this.ListBox1.SelectedIndex = -1;
			this.ListBox1.ShowColumnHeader = false;
			this.ListBox1.Size = new System.Drawing.Size(184, 96);
			this.ListBox1.TabIndex = 1;
			this.ListBox1.ThemesEnabled = true;
			this.ListBox1.TopIndex = 1;
			// 
			// textBox1
			// 
			this.textBox1.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
			this.textBox1.Location = new System.Drawing.Point(232, 176);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(104, 20);
			this.textBox1.TabIndex = 2;
			this.textBox1.Text = "";
			this.textBox1.TextChanged += new System.EventHandler(this.textBox1_TextChanged);
			// 
			// listBox2
			// 
			this.listBox2.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left)));
			this.listBox2.Location = new System.Drawing.Point(16, 24);
			this.listBox2.Name = "listBox2";
			this.listBox2.Size = new System.Drawing.Size(184, 134);
			this.listBox2.TabIndex = 3;
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(8, 176);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(208, 23);
			this.button1.TabIndex = 4;
			this.button1.Text = "Scroll GrilListControl";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// ListBoxSample3
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(424, 230);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.listBox2);
			this.Controls.Add(this.ListBox1);
			this.Controls.Add(this.textBox1);
			this.Name = "ListBoxSample3";
			this.Text = "GridListControl Sample1";
			((System.ComponentModel.ISupportInitialize)(this.ListBox1)).EndInit();
			this.ResumeLayout(false);

		}

		#endregion

		private void Grid_DrawCell(object sender, GridDrawCellEventArgs e)
		{
			GridControl grid = sender as GridControl;
			if(grid.CurrentCell.HasCurrentCellAt(e.RowIndex))
			{
				e.Style.ResetBorders();
				if(grid.Focused)
				{
					e.Style.BorderMargins.Top = 1;
					if(e.ColIndex == this.ListBox1.ImageColumn)
						e.Style.BorderMargins.Left = 2;
				}
			}
		
		}
		
	
		private void textBox1_TextChanged(object sender, System.EventArgs e)
		{
			ListBox1.FindItem(this.textBox1.Text,true,0,true);

			uint LB_FINDSTRING = 0x018F;
			IntPtr x = SendMessage(this.listBox2.Handle, LB_FINDSTRING, -1, textBox1.Text);
			listBox2.SelectedIndex = x.ToInt32(); 

			SendMessage(ListBox1.Handle,WM_VSCROLL ,SB_PAGETOP,0);
			SendMessage(listBox2.Handle,WM_VSCROLL ,SB_PAGETOP,0);
			for(int i=0; i<listBox2.SelectedIndex;i++)
			{
				SendMessage(ListBox1.Handle,WM_VSCROLL ,SB_LINEDOWN,0);
				SendMessage(listBox2.Handle,WM_VSCROLL ,SB_LINEDOWN,0);
			}

			//ListBox1.Grid.VScrollIncrement = 8;
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
//			//int n = ListBox1.FindString(this.textBox1.Text,0);
//			//if(this.textBox1.Text == "")
//			//	n =-1;
//			//this.ListBox1.SelectedIndex = n;
//
//			ListBox1.FindItem(this.textBox1.Text,true,0,true);
//
//			uint LB_FINDSTRING = 0x018F;
//			IntPtr x = SendMessage(this.listBox2.Handle, LB_FINDSTRING, -1, textBox1.Text);
//			listBox2.SelectedIndex = x.ToInt32(); 
//
//			SendMessage(ListBox1.Handle,WM_VSCROLL ,SB_PAGETOP,0);
//			SendMessage(listBox2.Handle,WM_VSCROLL ,SB_PAGETOP,0);
//			for(int i=0; i<listBox2.SelectedIndex;i++)
//			{
//				SendMessage(ListBox1.Handle,WM_VSCROLL ,SB_LINEDOWN,0);
//				SendMessage(listBox2.Handle,WM_VSCROLL ,SB_LINEDOWN,0);
//			}		

			ListBox1.Grid.VScrollBar.Value = ListBox1.SelectedIndex + 1;
			//ListBox1.Grid.ScrollCellInView(ListBox1.SelectedIndex, 1);
		}	
	}


	public class USState
	{
		private string myShortName ;
		private string myLongName ;
		private int imgIndex;
   
		public  USState(string strLongName, string strShortName, int imageIndex)
		{
			this.myShortName = strShortName;
			this.myLongName = strLongName;
			this.imgIndex = imageIndex;
		}

		public string ShortName
		{
			get
			{
				return myShortName;
			}
		}

		public string LongName
		{
      
			get
			{
				return myLongName ;
			}
		}

		public int ImageIndex
		{
			get
			{
				return imgIndex;
			}
			set
			{
				imgIndex = value;
			}
		}


		public override string ToString()
		{
			return this.ShortName + " - " + this.LongName;
		}
	}
}

